"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.getAllConnectedDevices=getAllConnectedDevices,exports.getAvailablePlatform=getAvailablePlatform,exports.installAndRun=installAndRun,exports.installdbg=installdbg,exports.installmkp=installmkp,exports.runapp=runapp;var _fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_chalk=_interopRequireDefault(require("chalk")),_inquirer=_interopRequireDefault(require("inquirer")),_adbCommander=_interopRequireDefault(require("adb-commander")),_server=require("@hap-toolkit/server"),_sharedUtils=require("@hap-toolkit/shared-utils"),_compile=require("./compile"),_utils=require("./utils");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const{clientRecordPath:clientRecordPath}=_sharedUtils.globalConfig,ipRegExp=/^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,CLIENT_PORT=39517;async function connectDevice(e=""){try{const r="是，连接新的wifi设备";if(!e){if((await _inquirer.default.prompt([{name:"type",type:"list",message:"（USB设备会自动连入）选择是否要连接新的wifi设备，稍后需填写其IP地址:",choices:[r,"跳过，保持已连接的设备"]}])).type!==r)return Promise.resolve();e=(await _inquirer.default.prompt([{name:"ip",message:'请输入设备在wifi下的ip地址(如192.168.1.1)，并确保电脑与设备在同一wifi下。若需输入多个ip，请以","分隔:',default:null}])).ip}if(0===e.length)return _sharedUtils.colorconsole.info("没有输入任何ip地址，将连接已连接过的设备"),Promise.resolve();const t=e.trim().split(","),o=t.filter((e=>!ipRegExp.test(e)));if(!o||!o.length){const e=Array.from(t,(e=>_adbCommander.default.exeCommand(`adb connect ${e}:5555`).then((({result:r,err:t})=>{(t||r.indexOf("failed")>=0)&&(_sharedUtils.colorconsole.error(`wifi连接ip： "${e}" 的设备失败了`),process.exit()),_sharedUtils.colorconsole.info(`wifi连接ip： "${e}" 的设备成功了`);let o={ip:e,port:CLIENT_PORT};return(0,_sharedUtils.recordClient)(clientRecordPath,o),Promise.resolve()}))));return Promise.all(e).then((()=>(_sharedUtils.colorconsole.log("所有新的WIFI设备连接完毕"),Promise.resolve()))).catch((()=>{process.exit()}))}o.map((e=>{_sharedUtils.colorconsole.error(`ip: ${e} is invalid IP`)})),process.exit()}catch(e){return Promise.reject(new Error(`连接设备出错，错误信息：${e.message}`))}}async function getConnectDevices(e=!0){try{return _adbCommander.default.deviceList().then((({deviceList:r,err:t})=>{if(t){const e="获取adb设备连接信息出错";_sharedUtils.colorconsole.throw(e,t)}if(r.length>0)return e&&_sharedUtils.colorconsole.info(`通过adb连接的设备的有： ${_chalk.default.yellow(r.join(", "))}.`),Promise.resolve(r);{const e="当前无设备连接，请依次检查以下准备工作是否完成：\n  1. 设备是否启动;\n  2. 是否处于同一局域网WI-FI;\n  3. 设备是否可以USB连接电脑;";_sharedUtils.colorconsole.throw(e)}}))}catch(e){return Promise.reject(new Error(e.message))}}async function downloadApk(e,r){let t="";const{apkVersion:o}=e;t=r?(0,_utils.getQuickappDebuggerUrl)(o):(0,_utils.getQuickappPreviewUrl)(o);const s=_path.default.basename(t),l=_path.default.join(__dirname,"./apk/",s);return _fs.default.existsSync(l)?(_sharedUtils.colorconsole.log("安装包已下载过，现使用缓存文件安装"),l):(0,_utils.downloadFile)(t,s).then((e=>(_sharedUtils.colorconsole.info(e),l))).catch((e=>{_sharedUtils.colorconsole.error("下载安装包失败",e),process.exit()}))}async function installApk(e,r=[],t,o,s){const{forceInstall:l=!1}=e;try{const e=Array.from(r,(e=>_adbCommander.default.isInstalled(e,o).then((async({isInstalled:r,err:a})=>a?(_sharedUtils.colorconsole.error(`在设备 "${_chalk.default.yellow(e)}" 上安装应用 "${_chalk.default.yellow(s)}" 失败了，错误信息：${JSON.stringify(a)} `),Promise.reject(new Error(JSON.stringify(a)))):!1===r||l?(await _adbCommander.default.uninstall(e,o),_sharedUtils.colorconsole.log(`开始在设备 "${_chalk.default.yellow(e)}" 上安装应用："${_chalk.default.yellow(s)}" `),_adbCommander.default.install(e,t).then((({result:r,err:t})=>t?(_sharedUtils.colorconsole.error(`在设备 "${_chalk.default.yellow(e)}" 上安装应用 "${_chalk.default.yellow(s)}" 失败了，请排查问题后重试 `),Promise.reject(new Error(`在设备 "${_chalk.default.yellow(e)}" 上安装应用 "${_chalk.default.yellow(s)}" 失败了，请排查问题后重试 `))):_adbCommander.default.isInstalled(e,o).then((({isInstalled:r,err:t})=>{if(!0===r)return _sharedUtils.colorconsole.info(`在设备 "${_chalk.default.yellow(e)}" 上安装应用 "${_chalk.default.yellow(s)}" 成功 `),Promise.resolve()}))))):(_sharedUtils.colorconsole.warn(`在设备 "${_chalk.default.yellow(e)}" 上已经安装过应用 "${_chalk.default.yellow(s)}"，因此这次安装没有继续`),Promise.resolve())))));return Promise.all(e).then((()=>(_sharedUtils.colorconsole.log("所有设备安装完毕"),Promise.resolve()))).catch((()=>{process.exit()}))}catch(e){return Promise.reject(e)}}async function startServer(e){const{address:r}=await(0,_server.launchServer)({clearRecords:!0});return await(0,_compile.compile)("native","dev",!0,e),r}async function installdbg(e,r=!0){try{const{ip:t}=e;r&&await connectDevice(t);const o=await getConnectDevices(r),s=await queryDevice(o,"安装快应用调试器"),l=await downloadApk(e,!0);return await installApk(e,s,l,"org.hapjs.debugger","快应用调试器"),Promise.resolve("所有设备安装快应用调试器成功")}catch(e){return Promise.reject(new Error(`安装调试器失败，错误信息：${e.message}`))}}async function installmkp(e,r=!0){try{const{ip:t}=e;r&&await connectDevice(t);const o=await getConnectDevices(r),s=await queryDevice(o,"安装快应用预览版"),l=await downloadApk(e);return await installApk(e,s,l,"org.hapjs.mockup","快应用预览版"),Promise.resolve("所有设备安装快应用预览版成功")}catch(e){return Promise.reject(new Error(`安装快应用预览版失败，错误信息：${e.message}`))}}async function queryDevice(e,r=""){if(!e||0===e.length)return void _sharedUtils.colorconsole.error("尚没有连接任何设备，请确认后重试");const t="全部已连接设备",o=(await _inquirer.default.prompt([{name:"device",type:"list",message:`请选择需要执行命令"${r}"的设备:`,choices:[...e,t]}])).device;return o===t?e:[o]}async function startDebugger(e=[],r){_sharedUtils.colorconsole.info("正在为已连接的设备启动调试器中...");const t=Array.from(e,(e=>_adbCommander.default.exeCommand(`adb -s ${e} shell am start -n "org.hapjs.debugger/.MainActivity" ${r}`).then((({err:r})=>r?(_sharedUtils.colorconsole.error(`在设备 "${_chalk.default.yellow(e)}" 上启动"快应用调试器"失败，请排查问题后重试`),Promise.reject(new Error(JSON.stringify(r)))):(_sharedUtils.colorconsole.info(`在设备 "${_chalk.default.yellow(e)}" 上启动"快应用调试器"成功`),Promise.resolve())))));return Promise.all(t).then((()=>(_sharedUtils.colorconsole.info("所有设备的调试器启动完毕"),Promise.resolve()))).catch((()=>{process.exit()}))}async function runapp(e,r=!0,t=!0){try{const{debugMode:o=!1,cardMode:s=!1}=e;let l="",a="",i="";const n=process.cwd();if((0,_utils.checkQuickappDir)(n),s){_sharedUtils.colorconsole.warn("请在安卓系统中开启快应用调试器与预览版引擎的「自启动」与「关联启动」权限");const e=(0,_utils.getCardContent)(n);if(e){const r=Object.keys(e);if(r.length>1){const t=await _inquirer.default.prompt([{name:"cardName",type:"list",message:"请选择调试的卡片:",choices:r}]);a=e[t.cardName].path||`/${t.cardName}`}else a=e[r[0]].path||`/${r[0]}`;i+=`-e cardMode true -e cardPath ${a}`}}(0,_sharedUtils.clearProjectRecord)(clientRecordPath),l=await startServer(e),i+=` -e path ${l}`,l||(_sharedUtils.colorconsole.error("启动本地快应用服务失败，请排查后重试"),process.exit()),t&&await connectDevice();const c=await getConnectDevices(r);c&&0!==c.length||(_sharedUtils.colorconsole.error("没有可用的连接设备！"),process.exit()),await startDebugger(c,i),setTimeout((async()=>{const e=await(0,_utils.getClients)();e||(_sharedUtils.colorconsole.error("没有可用的连接设备！"),process.exit());for(let r of e){const{sn:e,ip:t}=r;if("127.0.0.1"===t&&e.includes(":5555"))continue;const s=e&&e.length>0?e:t,l=()=>{_sharedUtils.colorconsole.error(`"${s}" 设备获取运行平台列表时错误,延迟3s后再次请求`),setTimeout((()=>{a()}),3e3)},a=async()=>{let e=await(0,_utils.sendReq)(r,"/availablePlatforms");e||l(),e=JSON.parse(e);const{availablePlatforms:a}=e;if(a){let e;if(0===a.length)return void _sharedUtils.colorconsole.error(`${t} 设备尚未安装快应用引擎`);if(1===a.length)e=a[0].pkg;else if(a.length>1){const r=await _inquirer.default.prompt([{name:"name",type:"list",message:`在设备"${s}"上检测到多个快应用引擎，请选择运行平台:`,choices:a}]);a.forEach((t=>{t.name===r.name&&(e=t.pkg)}))}"OK"===await(0,_utils.sendReq)(r,"/platform",{selectedPlatform:e})&&(0,_utils.sendReq)(r,"/update",{debug:o})}else l()};await a()}}),3e3)}catch(e){return Promise.reject(new Error(`运行RPK到设备上出错，错误信息：${e.message}`))}}async function installAndRun(e){try{const r=process.cwd();(0,_utils.checkQuickappDir)(r),await installdbg(e),await installmkp(e,!1),await runapp(Object.assign({},e,{enableServerWatch:!0}),!1,!1)}catch(e){return Promise.reject(new Error(`一键调试出错，错误信息：${e.message}`))}}async function getAvailablePlatform(e){try{const{ip:r,port:t,sn:o}=e;r&&ipRegExp.test(r)||(_sharedUtils.colorconsole.error("没有传入正确的ip地址，示例 --ip 127.0.0.1"),process.exit()),t||(_sharedUtils.colorconsole.error("没有传入正确的端口地址，示例 --port 39517"),process.exit()),o||(_sharedUtils.colorconsole.error('没有传入正确的设备序列号，可通过"adb devices"指令查看已连接的设备序列号 \n 如果是WIFI连接的设备，格式为 "ip地址:5555"'),process.exit());let s={ip:r,port:t};const l=()=>{_sharedUtils.colorconsole.error("设备获取运行平台错误,延迟3s后再次请求"),setTimeout((()=>{a()}),3e3)},a=async()=>{let e=await(0,_utils.sendReq)(s,"/availablePlatforms");if(e)if(e=JSON.parse(e),e.availablePlatforms){const r=e.availablePlatforms;_sharedUtils.colorconsole.info(`设备"${o}"的快应用引擎列表有：${r.join(", ")}`)}else l();else l()};_adbCommander.default.exeCommand(`adb -s ${o} shell am start -n "org.hapjs.debugger/.MainActivity"`).then((({err:e})=>{e&&(_sharedUtils.colorconsole.error("调试器没有正常启动，请检查是否已安装"),process.exit()),_sharedUtils.colorconsole.info(`调试器成功运行在设备"${_chalk.default.yellow(o)}"`),_sharedUtils.colorconsole.info(`设备"${o}"获取快应用引擎列表中...`),a()}))}catch(e){_sharedUtils.colorconsole.error(`获取设备上的快应用引擎列表出错，错误信息：${e.message}`)}}async function getAllConnectedDevices(e){try{return _adbCommander.default.deviceList().then((({deviceList:e,err:r})=>{if(!r)return Promise.resolve(e);_sharedUtils.colorconsole.throw(r)}))}catch(e){return Promise.reject(new Error(`获取所有连接上的设备数组出错，错误信息：${e.message}`))}}
//# sourceMappingURL=debug.js.map
