"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.validateCardSize=validateCardSize,exports.validateJson=validateJson,exports.validateManifest=validateManifest,exports.validateProject=validateProject,exports.validateSitemap=validateSitemap,exports.validateSkeleton=validateSkeleton;var _fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_ajv=_interopRequireDefault(require("ajv")),_ajvErrors=_interopRequireDefault(require("ajv-errors")),_manifestSchema=_interopRequireDefault(require("./manifest-schema")),_sharedUtils=require("@hap-toolkit/shared-utils"),_packager=require("@hap-toolkit/packager");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const MAIN_PKG_NAME=_sharedUtils.compileOptionsMeta.MAIN_PKG_NAME,RPKS_SUPPORT_VERSION_FROM=1040;function validateProject(e,o){if(!_fs.default.existsSync(e))throw _sharedUtils.colorconsole.throw(`请确认项目%projectDir%/${o}/下存在manifest.json文件：${e}`),new _sharedUtils.KnownError(`找不到 ${o}/manifest.json`)}const docSrc="https://doc.quickapp.cn/framework/manifest.html";function validateJson(e,o){const t=new _ajv.default({allErrors:!0,jsonPointers:!0});if((0,_ajvErrors.default)(t),t.addKeyword("requireError",{validate:function(e,o){if(!(o.widgets||o.entry&&o.pages)){const o=`快应用项目 manifest.json 中，router 字段下 ${JSON.stringify(e)} 字段为必填`;_sharedUtils.colorconsole.error(o)}return!0}}),t.validate(_manifestSchema.default,e),!t.errors)return[];return t.errors.map((e=>{const t=`校验 ${o} 错误 \n`+e.dataPath.split("/").filter(Boolean).join(".")+e.message+`\n参考: ${docSrc}`;return new Error(t)}))}function validateManifest(e,o,t){validateJson(o,"manifest.json").forEach((e=>{_sharedUtils.colorconsole.error(e.message)}));const{subpackages:s}=o;!t.disableSubpackages&&s&&s.length>0&&validateManifestSubpackages(e,s)}function validateManifestSubpackages(e,o){const t=/^\w+$/,s=/^\w[\w-/]*$/,r=[],a=[],n=_path.default.join(e,"i18n"),i=_path.default.join(e,"lottie"),l=_path.default.join(e,"skeleton");let c="",d="",h="",f=0;o.forEach(((o,u)=>{c=o.name,d=o.resource,h=d&&_path.default.join(e,d),f=u+1,c?t.test(c)?c===MAIN_PKG_NAME?_sharedUtils.colorconsole.throw(`第${f}分包的名字'${c}'是主包保留名，请修改`):r.indexOf(c)>-1?_sharedUtils.colorconsole.throw(`第${f}分包的名字'${c}'已存在，请修改`):r.push(c):_sharedUtils.colorconsole.throw(`第${f}分包的名字'${c}'不合法，只能是数字字母下划线组成，请修改`):_sharedUtils.colorconsole.throw(`第${f}分包的名字不能为空，请添加`),d?s.test(d)?a.indexOf(d)>-1?_sharedUtils.colorconsole.throw(`第${f}分包的资源'${d}'已被使用，请修改`):_fs.default.existsSync(h)?h===n?_sharedUtils.colorconsole.throw(`第${f}分包的资源'${d}'，文件目录'${h}'，i18n文件目录不能作为分包，请修改`):h===i?_sharedUtils.colorconsole.throw(`第${f}分包的资源'${d}'，文件目录'${h}'，lottie文件目录不能作为分包，请修改`):h===l?_sharedUtils.colorconsole.throw(`第${f}分包的资源'${d}'，文件目录'${h}'，骨架屏文件目录不能作为分包，请修改`):function(e,o){for(let t=0,s=a.length;t<s;t++){const s=a[t];if(e.startsWith(s)||s.startsWith(e))return _sharedUtils.colorconsole.throw(`第${o}分包的资源'${e}'与第${t+1}分包的资源'${s}'有包含关系，请修改`),!0}return!1}(d,f)||a.push(d):_sharedUtils.colorconsole.throw(`第${f}分包的资源'${d}'，文件目录'${h}'不存在，请修改`):_sharedUtils.colorconsole.throw(`第${f}分包的资源名'${d}'不合法，只能是 数字字母_ 开头，数字字母_-/ 组成，请修改`):_sharedUtils.colorconsole.throw(`第${f}分包的资源名不能为空，请添加`),o.standalone&&o.icon&&!_fs.default.existsSync(_path.default.join(e,o.icon))&&_sharedUtils.colorconsole.throw(`第${f}分包配置的icon不存在，请修改`),o.standalone&&o.banner&&!_fs.default.existsSync(_path.default.join(e,o.banner))&&_sharedUtils.colorconsole.throw(`第${f}分包配置的banner不存在，请修改`)})),_sharedUtils.colorconsole.warn(`项目已配置分包，若想使用分包功能，请确保平台版本 >= ${RPKS_SUPPORT_VERSION_FROM}`)}function validateSitemap(e,o){const t=_path.default.join(e,"sitemap.json");if(_fs.default.existsSync(t)){const e=require(t).rules,s=Object.keys(o.router.pages||{});e.forEach(((e,o)=>{const t=e.page;return"*"===t||s.includes(t)||_sharedUtils.colorconsole.throw(`sitemap rules第${o+1}项配置错误，该page不存在：${t}`),t}))}}function validateSkeleton(e,o){const t=(0,_packager.getSkeletonConfig)(e),s=o.router.pages||{};if(t){const o=_path.default.join(e,"skeleton/page"),r=t.singleMap||{},a=t.anchorMaps||[];Object.keys(r).forEach((e=>{s[e]||_sharedUtils.colorconsole.throw(`骨架屏singleMap配置页面 ${e} 在manifest上无定义，请检查`);const r=_path.default.join(o,t.singleMap[e]);_fs.default.existsSync(r)||_sharedUtils.colorconsole.throw(`骨架屏singleMap配置页面 ${e} 的sk文件 ${r} 不存在，请检查`)})),Array.isArray(a)||_sharedUtils.colorconsole.throw("骨架屏anchorMaps字段值需为数组，请检查"),a.forEach(((e,t)=>{const{page:r,skeletonMap:a}=e;r||_sharedUtils.colorconsole.throw(`骨架屏anchorMaps第 ${t+1} 配置page值不能为空，请检查`),s[r]||_sharedUtils.colorconsole.throw(`骨架屏anchorMaps第 ${t+1} 配置page值 ${r} 在manifest上无定义，请检查`),Object.keys(a||{}).forEach((e=>{const s=_path.default.join(o,a[e]);_fs.default.existsSync(s)||_sharedUtils.colorconsole.throw(`骨架屏anchorMaps第 ${t+1} 配置锚点 ${e} 的sk文件 ${s} 不存在，请检查`)}))}))}}function validateCardSize(e,o){const t=o.router.widgets;if(t){const e=["1","2","4","8","FULL","AUTO"];Object.keys(t).forEach(((o,s)=>{if(t[o].size){t[o].size.join(",").replace(/x/g,",").split(",").forEach((t=>{e.includes(t)||_sharedUtils.colorconsole.throw(`manifest.json配置的卡片 ${o} 的size不合规范,长宽都要在['1','2','4','8','FULL','AUTO']范围内`)}))}}))}}
//# sourceMappingURL=validate.js.map
